Recipes, orders and scheduled jobs

Job Panel <smart-job-panel>

JobPanel shows what a station does on its own - the jobs it runs because of the clock rather than because of a person - with what each does, when it runs and how it went last time.

Getting Started with React JobPanel Component

The Smart.Industrial React components need React 18 or later, because they render through react-dom/client. The steps use Vite with its react-ts template.

The complete demo in React is on the demo page, file by file.

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart.Industrial

npm install smart-industrial

3 Import styles and render the component

The sample replaces the content of src/App.tsx. It imports the stylesheets and the JobPanel component, sets the properties the demo sets and handles the jobRun event. It compiles under the template's strict TypeScript settings.

import 'smart-industrial/source/styles/smart.default.css';
import 'smart-industrial/source/styles/smart.industrial-elements.css';
import 'smart-industrial/source/styles/smart.industrial.css';
import { JobPanel } from 'smart-industrial/react/jobpanel';

function App() {
  // Raised when the operator runs a job by hand, after the confirmation when
  // one is asked for.
  const handleJobRun = (event: CustomEvent) => {
    const { id, name, action } = event.detail;
    console.log('jobRun', id, name, action);
  };

  return (
    <JobPanel
      label="Line 3 jobs"
      onJobRun={handleJobRun}
    />
  );
}

export default App;

The template's src/main.tsx renders App and needs no change.

Each component has an entry point of its own, and the sample imports from it. The entry point with all the components, smart-industrial/react, puts every component into the bundle, about 2.5 MB minified. Built with Vite, the Faceplate sample has 390 kB of JavaScript, React included, with smart-industrial/react/faceplate.

4 Run the dev server

npm run dev

Vite prints the URL of the application, usually http://localhost:5173/.

TypeScript Support

The types ship with smart-industrial. A type-only import of the component and its props uses import type, which the template's verbatimModuleSyntax requires:

import type { JobPanel, JobPanelProps } from 'smart-industrial/react/jobpanel';

Each on* callback receives a CustomEvent whose detail is typed for that event, so the editor lists its fields. A handler typed (event: CustomEvent) => void, as in the sample, accepts it as well.

Accessibility

The keyboard interaction, roles and announcements of the component are on its accessibility page; they are the same in React.

Recipes, orders and scheduled jobs

Job Panel <smart-job-panel>

JobPanel shows what a station does on its own - the jobs it runs because of the clock rather than because of a person - with what each does, when it runs and how it went last time.

Angular JobPanel - Setup

The Smart.Industrial Angular modules are compiled for Angular 13 and later. An NgModule application needs Angular 13 or later. A standalone component that imports JobPanelModule needs Angular 14 or later.

Each component has its own Angular module. JobPanelModule declares and exports JobPanelComponent, which is not a standalone component. A standalone component lists the module in its imports, and an NgModule application lists it in the imports of its module. Steps 1 to 5 build a standalone application. Step 6 covers an NgModule application.

The complete demo in Angular is on the demo page, file by file.

1 NPM Install

The Angular modules are in the smart-industrial package:

npm install smart-industrial

2 Register styles

The stylesheets go into the styles of the build options in angular.json, next to the existing entries:

"styles": [
	"node_modules/smart-industrial/source/styles/smart.default.css",
	"node_modules/smart-industrial/source/styles/smart.industrial-elements.css",
	"node_modules/smart-industrial/source/styles/smart.industrial.css"
]

smart.default.css is the base theme and smart.industrial-elements.css styles the Industrial components. smart.industrial.css is the Industrial theme, which applies to components with theme="industrial". For theme="industrial-dark", the package also has smart.industrial-dark.css.

3 Import the Angular module

The application imports JobPanelModule from the component's entry point. JobPanelComponent reaches a template through this module. A standalone component that lists JobPanelComponent itself in its imports does not compile (NG2011).

import { JobPanelModule } from 'smart-industrial/angular/jobpanel';

Each component has an entry point of its own, and an application imports from those. The entry point with all the components, smart-industrial/angular, puts every component into the bundle. In a production build of the Faceplate sample, the main bundle is 274 kB with FaceplateModule and 8.9 MB with SmartIndustrialModule.

4 Root component (standalone)

The sample has three files: the component, its template in step 5, and src/main.ts. They replace the files of the same name that the CLI generated.

src/app/app.ts

import { Component } from '@angular/core';
import { JobPanelModule } from 'smart-industrial/angular/jobpanel';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [JobPanelModule],
  templateUrl: './app.html'
})
export class App {
  // Raised when the operator runs a job by hand, after the confirmation when
  // one is asked for.
  onJobRun(event: CustomEvent): void {
    const { id, name, action } = event.detail;
    console.log('jobRun', id, name, action);
  }
}

src/main.ts

import { bootstrapApplication } from '@angular/platform-browser';
import { App } from './app/app';

bootstrapApplication(App).catch((err) => console.error(err));

A project from Angular CLI 20 or later already has these files. Its src/main.ts also passes an appConfig, which can stay. An older project names its root component AppComponent, in app.component.ts, and the sample does not use it.

5 Template (standalone)

src/app/app.html holds the markup. Each event of the component is an output named after it, such as (onJobRun), and $event is the CustomEvent.

<smart-job-panel
  label="Line 3 jobs"
  (onJobRun)="onJobRun($event)"
></smart-job-panel>

6 NgModule application

An NgModule application uses the same package and styles. Its module lists JobPanelModule in imports and declares the component that uses the template from step 5. src/main.ts starts the module with bootstrapModule. This works on Angular 13 and later. From Angular 19, a component declared in a module needs standalone: false.

Run

ng serve or npm start starts the development server at http://localhost:4200/.

Production build

A project created with ng new has an error budget of 1 MB for the initial bundle. The stylesheets alone come to 1.69 MB in a production build, because smart.default.css carries the base styles of the suite components that the Industrial components are built on. The initial bundle of the Faceplate sample is 2.00 MB, and ng build stops with a budget error. A higher initial budget in the production configuration of angular.json lets it pass:

"budgets": [
  { "type": "initial", "maximumWarning": "3MB", "maximumError": "4MB" },
  { "type": "anyComponentStyle", "maximumWarning": "4kB", "maximumError": "8kB" }
]

Each further component adds its module to the main bundle, so the budget grows with the number of components on the screen.

Smart UI for Angular - full documentation

Accessibility

The keyboard interaction, roles and announcements of the component are on its accessibility page; they are the same in Angular.

Recipes, orders and scheduled jobs

Job Panel <smart-job-panel>

JobPanel shows what a station does on its own - the jobs it runs because of the clock rather than because of a person - with what each does, when it runs and how it went last time.

Getting Started with Vue JobPanel Component

Smart.Industrial supports Vue 3.2.38 and later, with Vite. Vue uses the custom elements directly, so there is no wrapper to install.

The complete demo in Vue is on the demo page, file by file.

Scaffold with Vite (Vue 3)

The official scaffolding tool creates the project:

npm create vue@latest

The tool asks about TypeScript, Router, Pinia and other options. The defaults are enough for the sample.

cd <your-project-name>
npm install
npm install smart-industrial
npm run dev
	

Vue + TypeScript

A TypeScript project has vite.config.ts in place of vite.config.js, with the same configuration.

Teach Vue about custom elements

The isCustomElement option of the Vue plugin passes smart-* tags to the browser as custom elements. Without it, Vue looks for a Vue component named smart-job-panel and warns that it cannot resolve it. Other plugins that the scaffold added, such as vueDevTools(), stay in the list.

import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

export default defineConfig({
  plugins: [
    vue({
      template: {
        compilerOptions: {
          isCustomElement: (tag) => tag.startsWith('smart-')
        }
      }
    })
  ],
  resolve: {
    alias: {
      '@': fileURLToPath(new URL('./src', import.meta.url))
    }
  }
})
	

App.vue example

The sample replaces src/App.vue. It imports the stylesheets and the module that defines <smart-job-panel>, sets the properties the demo sets and handles the jobRun event.

<script setup>
import 'smart-industrial/source/styles/smart.default.css';
import 'smart-industrial/source/styles/smart.industrial-elements.css';
import 'smart-industrial/source/styles/smart.industrial.css';
import 'smart-industrial/source/modules/smart.jobpanel.js';

// Raised when the operator runs a job by hand, after the confirmation when one
// is asked for.
function onJobRun(event) {
  const { id, name, action } = event.detail;
  console.log('jobRun', id, name, action);
}
</script>

<template>
  <smart-job-panel
    label="Line 3 jobs"
    @jobRun="onJobRun"
  ></smart-job-panel>
</template>

A listener for an event with an uppercase letter in its name, such as @jobRun, needs Vue 3.2.38 or later. Earlier versions listen for job-run, which the component never raises.

With TypeScript, the script tag is <script setup lang="ts"> and the handler's parameter is typed as CustomEvent.

Run and build

The development server runs at http://localhost:5173/:

npm run dev

The production build goes to ./dist:

npm run build

Read more about using Smart UI for Vue.

Accessibility

The keyboard interaction, roles and announcements of the component are on its accessibility page; they are the same in Vue.